<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace Base\Model;

use Base\Common\ArrayUtil;

class Search extends Base {

    public function getIndexName(){
        $tableName = $this->getTableName(1);
        return 'table-'.$tableName;
    }

    // 提供搜索的字段
    public function getSearchField(){
        return array('id', 'goods', 'desc');
    }

    /**
     * 发布到es
     * @param bool $isRefreshALL  是否全部更新
     * @return string|null
     */
    public function release($isRefreshALL)
    {
        $indexName = $this->getIndexName();
        $searchField = $this->getSearchField();
        if ($isRefreshALL) {
            EsBase::deleteIndex($this->getIndexName());
            $this->getORM()->update(['publish_time' => date('Y-m-d H:i:s',  strtotime("-10 year"))]);
        }
        return $this->publish($indexName, $searchField, function ($data){
            $ids = array_column($data, 'id');
            $this->getORM()->where('id', $ids)
                ->update(['publish_time' => date('Y-m-d H:i:s', time())]);
        });
    }

    /**
     * 从es中获取
     * @param string $keyword
     * @param int $page
     * @param int $perpage
     * @return array
     */
    public function getByKeyword($keyword, $page, $perpage)
    {
        $searchField = $this->getSearchField();
        return $this->search($searchField, $keyword, $page, $perpage);
    }
    
    /**
     * mysql数据更新至ws
     * @param string $indexName     索引名称
     * @param array  $searchFields  可供搜索的字段
     * @param callable $callback    回调函数（用来更新时间等）
     * @return bool
     */
    public function publish($indexName, $searchFields, $callback)
    {
        $limit = 1000;  // 每次刷新es最多多少条
        $columns = $this->getTableScheme();
        $properties = EsBase::esMappingProperties($columns);
        foreach ($properties as $field => $map) {
            if (!in_array($field, $searchFields)) {
                unset($properties[$field]);
            }
        }
        $error = '';
        $page = 1;
        do {
            $offset = ($page - 1) * $limit;
            $datas = $this->getORM()
            ->where('update_time > publish_time')
            ->limit($limit, $offset)->order('id')->fetchAll();
            if (count($datas) == 0) {
                break;
            }else{
                $body = [];
                foreach ($datas as $data) {
                    $body[] = [
                        'index' => [
                            '_index' => $indexName,
                            '_type' => $indexName,
                            '_id' => $data['id'],
                        ],
                    ];
                    $body[] = ArrayUtil::takeKey($data, $searchFields);
                }
                if (count($body) > 0) {
                    $params = array('body' => $body);
                    $mapping = array(
                        '_source' => array('enabled' => true),
                        'properties' => $properties,
                    );
                    if(EsBase::batchCreateInsert($indexName, $indexName, $params, $mapping)) {
                        $error .= EsBase::getError().PHP_EOL;
                    }
                }
                $callback($datas);
            }
            $page++;
        } while (count($datas) > 0);
        return $error;
    }
    
    // es搜索
    public function search($searchField, $keyword, $page, $perpage)
    {
        $query = array();
        $should = array();
        foreach ($searchField as $field){
            if($field !== 'id'){
                $should[] = array(
                    'match' => array(
                        $field => $keyword
                    )
                );
            }
        }
        if (is_numeric($keyword) && $keyword < 4294967295) {
            $should[] = [
                'match' => [
                    // id为int类型必须限定长度
                    'id' => substr($keyword, 0, 10),
                ]
            ];
        }
        $query[] = [
            'bool' => [
                'should' => $should
            ]
        ];
        $searchParams = array();
        $searchField = EsBase::parseEsCondition($searchField);
        $searchParams['body']['query'] = $searchField;
        $searchParams['body']['query']['bool']['must'] = $query;
        $searchParams['size'] = $perpage;
        $searchParams['from'] = ($page - 1) * $perpage;
        $searchParams['_source'] = ['_id'];
        $searchParams['index'] = $searchParams['type'] = $this->getIndexName();
        
        $result =  EsBase::getEsClient()->search($searchParams);
        $total = $result['hits']['total'] ?? 0;
        $data = ['total' => $total, 'data' => array()];
        if ($total > 0) {
            $ids = array_column($result['hits']['hits'], '_id');
            $data['data'] = $this->getORM()->where('id', $ids)->fetchAll();
        }
        return $data;
    }
    
    
    public function getTableScheme(){
        $tableName = $this->getTableName(0);
        $dbName = \PhalApi\DI()->config->get('dbs.servers.db_master.name');
        $sql = "select COLUMN_NAME, DATA_TYPE from information_schema.COLUMNS
        where table_name = '{$tableName}' and table_schema = '{$dbName}';";
        return $this->getORM()->queryRows($sql);
    }
}
